//---------------------------------------------------------------------------

#ifndef MachineStatusFormH
#define MachineStatusFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "NumberEdit.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TMachineStatusFrm : public TForm
{
__published:	// IDE-managed Components
  TStaticText *StaticText2;
	TPanel *Panel1;
	TStaticText *StaticText1;
	TStaticText *RpmTxt;
	TStaticText *TempTxt;
	TStaticText *StaticText7;
	TStaticText *StaticText16;
	TStaticText *W2Txt;
	TStaticText *StaticText9;
	TStaticText *StaticText27;
	TStaticText *StaticText4;
	TStaticText *StaticText3;
	TStaticText *StaticText5;
	TPanel *Panel2;
	TBitBtn *StopBtn;
	TBitBtn *StartBtn;
	TPanel *Panel3;
	TStaticText *StaticText6;
	TSpeedButton *RpmBtn;
	TSpeedButton *TBtn;
	TSpeedButton *TimeBtn2;
	TStaticText *ZeroTxt;
	TEdit *RpmSetTxt;
	TEdit *TempSetTxt;
	TStaticText *TimeSetTxt;
	TStaticText *RunTimeTxt;
	TStaticText *TimeElapsedTxt;
	TStatusBar *SB;
	TStaticText *StaticText8;
	TStaticText *StaticText10;
	TStaticText *StaticText11;
	TStaticText *StaticText12;
	TStaticText *AcAcTxt;
	TStaticText *DeAcTxt;
	TStaticText *AcDeTxt;
	TStaticText *DeDeTxt;
	TStatusBar *SB2;
	TStaticText *StaticText13;
	TStaticText *MachStatTxt;
	TStaticText *TempLight;
	TStaticText *RpmLight;
  void __fastcall RpmBtnClick(TObject *Sender);
  void __fastcall TBtnClick(TObject *Sender);
  void __fastcall TimeBtn2Click(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall TempSetTxtEnter(TObject *Sender);
  void __fastcall TempSetTxtExit(TObject *Sender);
  void __fastcall RpmSetTxtEnter(TObject *Sender);
  void __fastcall RpmSetTxtExit(TObject *Sender);
  void __fastcall RpmSetTxtKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
  void __fastcall RpmSetTxtKeyPress(TObject *Sender, char &Key);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall StartBtnClick(TObject *Sender);
	void __fastcall StopBtnClick(TObject *Sender);
private:	// User declarations
	TNumberEdit * NumberEdit;                           ///Number editor
	void __fastcall UpdateRpmLight();        						///Checks to see if the rotor speed is stable & non-zero, then updates menu display
	void __fastcall UpdateTempLight();									///Checks for heating or cooling, updates light status
	void __fastcall UpdateActualValues();               ///Update all of the information on the 'Centrifuge Status' panel
	void __fastcall UpdateDesiredSettings();            ///Update all of the information on the 'Desired Values' panel
	void __fastcall UpdateElapsedTime();                ///Update the elapsed time and w^2t for testing mode
	void __fastcall ChangeRotorSpeed(int rpm);          ///The user has changed the rotor speed either through the RpmSet form or the edit box
	void __fastcall UpdateButtonStatus();								///Enable/disable the buttons depending on the machine status
	void __fastcall UpdateTBtnStatus(bool b);           ///Updates the availability of the temperature buttons and menu item, enable set by b, with an override if the experiment is started
	void __fastcall UpdateRBtnStatus(bool b);           ///Updates the availability of the rotor speed buttons and menu item, enable set by b
	void __fastcall UpdateTimeBtnStatus(bool b);        ///Updates the availability of the time buttons and menu item, enable set by b
	void __fastcall UpdateStartStopButtons();						/// Update the start-stop buttons
	void __fastcall UpdateMachineStatus();							/// Update the machine status, connection status, simulation status
	void __fastcall UpdateStatusBar();									/// Update the machine status, connection status, simulation status
	bool bIgnore;
	double LastUpdateTime;                              ///When was the last update performed. Only need in testing mode to calculate w^2t
public:		// User declarations
	__fastcall TMachineStatusFrm(TComponent* Owner);
	void __fastcall UpdateDisplay();                    ///Calls the following functions
};
//---------------------------------------------------------------------------
#endif
