//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "NumberEdit.h"
//---------------------------------------------------------------------------
__fastcall TNumberEdit::TNumberEdit(TComponent * Owner):TComponent(Owner)
{
  Max=9999;               ///Used to test if a number is in range
  Min=-9999;
  LastText="";
  IsInteger=false;
  HasExponent=false;
  HasPeriod=false;
}
//---------------------------------------------------------------------------
__fastcall TNumberEdit::~TNumberEdit()
{
}
//---------------------------------------------------------------------------
void TNumberEdit::Initialize(TObject * Sender,double dMin,double dMax,bool bIsInt)
{///Initialize this beast so that it can handle the key events
  if(!IsTEdit(Sender)) return;
  Value=(TEdit *)Sender;
  Min=dMin;
  Max=dMax;
  IsInteger=bIsInt;
  LastText=Value->Text;
  InitialText=LastText;
}
//---------------------------------------------------------------------------
bool TNumberEdit::HasAPeriod()
{
  bool ret;
  AnsiString decimalpoint = DecimalSeparator;
  ret=false;
  int l=LastText.Length();
  for(int i=1;i<=l;i++)
    {
      if(LastText[i]== decimalpoint) ret =true;
    }
  return ret;
}
//---------------------------------------------------------------------------
bool TNumberEdit::HasAnExponent()
{
  bool ret;
  ret=false;
  int l=LastText.Length();
  for(int i=1;i<=l;i++)
    {
      if(LastText[i]=='e' || LastText[i]=='E') ret =true;
    }
  return ret;
}
//---------------------------------------------------------------------------
bool TNumberEdit::IsANumber(AnsiString s)
{
  if(s == "0" || s == "1" || s == "2" || s == "3" ||
     s == "4" || s == "5" || s == "6" || s == "7" ||
     s == "8" || s == "9")
    {//It's a number
      return true;
    }
  else return false;
}
//---------------------------------------------------------------------------
bool TNumberEdit::IsAPeriod(AnsiString s)
{
  AnsiString decimalpoint = DecimalSeparator;
  if(s == decimalpoint) return true;
  else return false;
}
//---------------------------------------------------------------------------
bool TNumberEdit::IsPlusMinus(AnsiString s)
{
  if(s=="+" || s=="-") return true;
  else return false;
}
//---------------------------------------------------------------------------
bool TNumberEdit::IsExponent(AnsiString s)
{
  if(s=="e" || s=="E") return true;
  else return false;
}
//---------------------------------------------------------------------------
bool __fastcall TNumberEdit::IsTEdit(TObject * Sender)
{
  AnsiString jf=Sender->ClassName();
  if(jf == "TEdit") return true;
  return false;
}
//---------------------------------------------------------------------------
void __fastcall TNumberEdit::Change(TObject *Sender)
{
  if(!IsTEdit((Sender))) return;
  int position=Value->SelStart;
//  Value->Text=LastText;
  Value->SelStart=position;
}
//---------------------------------------------------------------------------
AnsiString TNumberEdit::GetValue()
{//Returns the value formatted pretty
  return Value->Text;
}
//---------------------------------------------------------------------------
void __fastcall TNumberEdit::KeyPress(TObject *Sender, char &Key)
{
  if(!IsTEdit(Sender)) return;
  AnsiString s=Value->Text;
  if(s.Length() == 0) s=" ";
  AnsiString k(Key);
  bool AddOK=false;
  if(!IsANumber(k) && !IsPlusMinus(k) && !IsExponent(k) && !IsAPeriod(k))
    {//Not an appropriate value
      if(Key == VK_BACK)
        {//Check to see if last character being removed by the Backspace key
          AnsiString s;
          s=Value->Text;
          if(Value->SelStart== s.Length()) return;
        }
      else
        {
          Key=0;
        }
      return;
    }
  if(IsInteger && IsExponent(k))
    {
      Key=0;
      return;
    }
  AnsiString FirstChar=LastText.SubString(1,1);
  AnsiString LastChar=LastText.SubString(LastText.Length(),1);
  //First character addition
  if(LastText.Length()==0)
    {
      if(IsPlusMinus(k) || IsANumber(k)) AddOK = true;
      else AddOK=false;
    }
  //Ordinary character addition
  if((IsPlusMinus(FirstChar) || IsPlusMinus(LastChar) || IsExponent(LastChar)) && IsANumber(k))
    {
      AddOK=true;
    }
  if(IsAPeriod(k) && !HasAPeriod() && !IsInteger) AddOK=true;//Add a period if one not already part of the number
  if(IsExponent(k) && !HasAnExponent() && !IsInteger) AddOK=true;                                       //Add e or E to end of character string
  if(IsExponent(LastChar) && IsPlusMinus(k)) AddOK=true;
  if(IsANumber(k) && (IsANumber(LastChar)|| IsAPeriod(LastChar) || IsExponent(LastChar))) AddOK=true;
  if(LastText.Length()==0 && (IsANumber(k) || IsAPeriod(k))) AddOK=true;                                //Add + or - to start
  if(IsPlusMinus(k) && Value->SelStart==0) AddOK=true;
  if(AddOK)
    {//Insert the character at the current position
      LastText=LastText.Insert(k,Value->SelStart+1);
      if(Value->SelLength != 0)
        {//User has selected some text. Remove the text before proceeding
          LastText=LastText.Delete(Value->SelStart+2,Value->SelLength);
        }
    }
  else Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TNumberEdit::KeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
  if(!IsTEdit(Sender)) return;
  if(Key ==VK_DELETE)
    LastText=LastText.Delete(Value->SelStart+1,1);
  if(Key ==VK_BACK)
    {
      AnsiString s;
      s=Value->Text;
      LastText=LastText.Delete(Value->SelStart,1);
    }
}
//---------------------------------------------------------------------------
bool __fastcall TNumberEdit::ExitQuery()
{
	if(LastText !="")
		{
			if(!TryStrToFloat(LastText,DValue))
				return false;
		}
	else return false;
	IValue=(int)DValue;
	if(DValue > Max || DValue < Min) return false;
	else return true;
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
