//---------------------------------------------------------------------------

#ifndef TemperatureSystemH
#define TemperatureSystemH
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
class TTemperatureSystem:public TComponent
{
private:
  void __fastcall SimulateTemperatureChanges(AnsiString DesiredTemperature);  ///Called during acceleration to simulate rotor temperature changes
public:
  __fastcall TTemperatureSystem(TComponent *Owner);
  __fastcall ~TTemperatureSystem();
 ///Hardware tests prior to starting an experiment
	AnsiString 	RequestedTemperature;                		 			 /// What is the temperature supposed to be. Eventually will be transmitted to the XLA. This buffers the edited text from the value being sent/recvd by the XLA
	double Temperature;                                        ///Temperature as a double
	double TemperatureDifference;                              ///Difference between desired and actual temperature
	double TemperatureTolerance;                               ///What is the acceptable value of the TemperatureDifference before allowing the timing begin
	bool bTemperatureOK;                                       ///Has the machine been at the desired temperature for the time period specified by the WaitAfterTemp
	bool __fastcall TemperatureInTolerance();                  ///Returns true if the temperature is within tolerance of the desired temperature
	bool __fastcall Update(AnsiString temp);     							 ///Update the temperature system status- returns true if update succeeds
};
#endif
 