//---------------------------------------------------------------------------

#ifndef XLDataH
#define XLDataH
#include <vcl.h>
#pragma hdrstop

#define XLSPDLEN			6			        // field lengths
#define XLTIMELEN 		6
#define XLTEMPLEN			5
#define XLW2TLEN  		9
#define XLANACCELLEN	4
#define XLANDECELLEN	4
#define XLACCELLEN		5
#define XLDECELLEN		5
#define	XLVACLEN			5

#define DEFAULT_SPD			"3000\0"		// default XL settings
#define	DEFAULT_TIME		"hold\0"
#define	DEFAULT_TEMP		"200\0"     // 20.0 C
#define	DEFAULT_W2T			"0\0"
#define	DEFAULT_ANACCEL	"0\0"
#define	DEFAULT_ANDECEL	"0\0"
#define	DEFAULT_ACCEL		"0\0"
#define	DEFAULT_DECEL		"0\0"
#define DEFAULT_VAC			"5000\0"

// XL statuses
#define	XLRUNNING			1		// Status code returned by XL as 3rd char in input buffer.
#define	STOPPING 			2		// JBA (08/12/02).
#define ACCELERATING 	3
#define DECELERATING	4

#define FORMAT 		1			        // used for getting formatted time, temp, w2t

#define DISPLAY_FORMAT		0			// format for w2t conversions
#define	FILE_FORMAT				1
class XLData:public TComponent
{///Class holding the XL information. Two will be created- Actual and Desired
private:
  char  speed[XLSPDLEN];
  char	time[XLTIMELEN];
  char	anAccel[XLANACCELLEN];
  char	anDecel[XLANDECELLEN];
  char	accel[XLACCELLEN];
  char	decel[XLDECELLEN];
  char  vac[XLVACLEN];
  char  w2t[XLW2TLEN];
  bool  scanning;
  int   status;
  int	  xlStatus;							// fuge status  (jba 08/12/02)
  bool  actualsObtained;
  bool  settingsObtained;
  long  runTime;
  long  elapsedTime;
  float mantissa;
	int   exponent;
	bool  IsConstructed;			 // true if the class has completed construction
public:
  __fastcall XLData(TComponent * Owner);
  __fastcall ~XLData() {};
//Setter and Getters for variables in this class
  void getAll (XLData* source);
  float Mantissa();
  void Mantissa (float val);
  int Exponent();
  void Exponent (int val);
  long ElapsedTime();
  void ElapsedTime (char* et);
  long RunTime();
  void IncRunTime();
  void ResetRunTime();
  void ActualsObtained (bool state);
  bool ActualsObtained();
  void SettingsObtained (bool state);
  bool SettingsObtained();
  bool Changed;
 //Getter functions- return data from the XL data structures
  char* getSpeed();
  int  	getSpeedInt();
  char* getTime();
  AnsiString getAnsiTime();
	char* 	getXLTime();
	double  getTimeSeconds();
	char* 	getTemp();
	AnsiString getTempAsString();
	double getTempAsDouble();
	int   getTempAsInt();
	char* getW2t (short mode);
	AnsiString getAnsiW2t();
	long 	getTimeHHHMM();
	char* getW2t();
  char* getVac();
  int   getVacInt();
  char* getAnAccel();
  char* getAnDecel();
  char* getAccel();
  char* getDecel();
  int		getStatus();
  int	getXlStatus();
//Setters: put data into the xl structures
  void PutAccelDecelDefaults();
  void putSpeed(char* data);
  void putTime(char* data);
	void putTemp(double Ta);
	void putTemp(char* data);
  void putTempInt(int data);
	void putW2t(char* data);
	void SaveW2t(AnsiString s);														 /// W2t saved in the DB separately from w2t from the machine
  void putVac(char* data);
  void putVacInt(int data);
  void putAnAccel(char* data);
  void putAnDecel(char* data);
  void putAccel(char* data);
  void putDecel(char* data);
  void putStatus(int dlgStatus);
  void putXlStatus(char stat);
 ///XML read/write
	AnsiString GetXMLString(AnsiString type);               ///Returns the <Channel> dddd </Channel> string for this channel
	void GetXMLStrings(AnsiString type,TStrings * strngs);	///Returns the XML strings for this channel
	AnsiString XMLDoc;																			/// Contains the name of the XMLDocument 
};

#endif
