//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "XLReadThread.h"
#include "baXLComm.h"
#include "Machine.h"

__fastcall TXLRead::TXLRead(bool CreateSuspended)
	: TThread(CreateSuspended)
{///Initialize the XLReadThread object
	Rxing   = false;													 ///not recieving data yet
	RxIdx   = 0;															 ///set the buffer index to start
  memset(RxBuffer,0,sizeof(RxBuffer));		   /// zero the incoming buffer
}
//---------------------------------------------------------------------------
void __fastcall TXLRead::DecodeMessage()
{///Pass the message queue to the decoder in XLCommIn
  Machine->MessageDecoder(RxBuffer,RxIdx-1);
  Rxing=false;
  RxIdx=0;
  memset(RxBuffer,0,sizeof(RxBuffer));
}
//---------------------------------------------------------------------------
void __fastcall TXLRead::Execute(){
  DWORD dwBytesRead;
  char STx=2;
  char ETx=3;
	//Automatically destroy the thread on termination of thread
	FreeOnTerminate = true;
  while(1)
  {///XL Read thread is put into a permanent loop that checks for characters coming in
    // SEE IF THERE ARE ANY CHARACTERS IN THE INTERNAL RECEIVE BUFFER.
    // IF THERE ARE, READ THEM. OTHERWISE, WAIT FOR CHARACTERS
    // TO ARRIVE OR LEAVE IF THE THREAD IS TERMINATED.
    if(!WaitCommEvent(OurHandle,&dwEvtMask,NULL))
      {///Something went wrong
        LPVOID lpMsgBuf;

        FormatMessage(
            FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            GetLastError(),
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
            (LPTSTR) &lpMsgBuf,
            0,
            NULL
        );
        //debug:      MessageBox( NULL, (LPTSTR)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );
        LocalFree( lpMsgBuf );
      }
   	if(Terminated) return;
  	ReadFile( OurHandle,
    	        &InBuffer, 			// Where to put the byte read
      	      InBufferSize,
        	    &dwBytesRead,  	// Bytes actually read
          	  &ov );
    unsigned long BytesXfered;
    GetOverlappedResult(OurHandle,&ov,&BytesXfered,True);
    if(BytesXfered >= 1)
      {///Only bother if something was received
        if(InBuffer[0] == STx)
          {/// Initialize RxBuffer if the first character is STX
            RxIdx = 0;
            memset(RxBuffer,0,sizeof(RxBuffer));
          }
        if((InBuffer[0] == STx) || (RxIdx != 0))
          {///Append InBuffer to growing message in RxBuffer
            for(int j=0; j<(int)BytesXfered; j++)
              {///Store from InBuffer to RxBuffer
                RxBuffer[RxIdx]=InBuffer[j];
                ++RxIdx;
              }
          }
        if(RxBuffer[0]==STx            ///Check if the message is ready for decoding
          && RxBuffer[RxIdx-1]== ETx)  ///If the message is bounded by STX and ETX, end transmission send RxBuffer to XLMessageDecoder
            Synchronize((TThreadMethod)&DecodeMessage);
      }
  }
}
//---------------------------------------------------------------------------
