//---------------------------------------------------------------------------
#ifndef XLScanDataH
#define XLScanDataH
#include <vcl.h>
#pragma hdrstop

#include <dir.h>

#define SEQUENTIAL				1
#define NON_SEQUENTIAL		0

#define NUM_CELLS					8
#define SCANNUMLEN				6
#define SCANTOTALLEN			6
#define SCANCELLLEN				2
#define SCANCONDLEN			128		// field lengths
#define SCANTYPELEN			 64
#define SCANDATAFILELEN	128
#define TIMELEN					 10
#define RADIUSLEN					6
#define WAVELEN	 					5
#define SCANMODELEN				3
#define REPLEN            5
#define OUTMODELEN				3
#define OUTTYPELEN				3
#define CHANLEN						3
#define FILTERLEN					4
#define COMMENTLEN				128

#define PPF_LEN						sizeof ("nnn.n")
#define NUM_CHANS					4
#define RAD_LEN           sizeof ("n.nnn")

#define DEFAULT_SCANNUM				"1\0"
#define DEFAULT_SCANTOTAL			"1\0"
#define DEFAULT_SCANCELL			"1\0"
#define DEFAULT_SCANCOND			"not scanning\0"
#define DEFAULT_SCANTYPE			"none\0"
#define DEFAULT_SCANDATAFILE	"none\0"
#define DEFAULT_CELLTIME			"0:00\0"
#define DEFAULT_ROTORTIME     "0:00\0"
#define DEFAULT_TOTALTIME     "0:00\0"
#define DEFAULT_SCANIDTYPE		0
#define ID_WAVESCAN           1

//**************************************************************************
///												XLScanData
//**************************************************************************/
class XLScanData:public TComponent
{///Contains the data that will be sent to the XLA for scanning
private:
 ///Data to be sent to the DAB
  char typeScan [NUM_CELLS] [3];
  char rMin [NUM_CELLS] [RADIUSLEN];
  char rMax [NUM_CELLS] [RADIUSLEN];
  char rStep [NUM_CELLS] [RADIUSLEN];
  char wMin [NUM_CELLS] [WAVELEN];
  char wMax [NUM_CELLS] [WAVELEN];
  char wStep [NUM_CELLS] [WAVELEN];
  char w2 [NUM_CELLS] [WAVELEN];
  char w3 [NUM_CELLS] [WAVELEN];
  char scanMode [NUM_CELLS] [SCANMODELEN];
  char replicates [NUM_CELLS] [REPLEN];
  char outputMode  [NUM_CELLS] [OUTMODELEN];
  char outputType [NUM_CELLS] [OUTTYPELEN];
  char channels [NUM_CELLS] [CHANLEN];
  char noDelayCal;
  char filterLevel [FILTERLEN];
 ///Used by the scan monitor and controller
	char scanNum [SCANNUMLEN];
	char scanTotal [SCANTOTALLEN];
	char scanCell [SCANCELLLEN];
	char scanType [SCANTYPELEN];
	char scanCondition [SCANCONDLEN];
	char scanDataFile [SCANDATAFILELEN];
	char estCellTime [NUM_CELLS] [TIMELEN];
	char estRotorTime [TIMELEN];
	char estTotalTime [TIMELEN];
	char timeLeft [TIMELEN];

  char filePath [64];
  char buff [10];
  void putDefaults();
public:
  __fastcall XLScanData(TComponent *Owner);
  __fastcall ~XLScanData();
  long incrementScanNum(); /* {
    char buff [20];
    putScanNum (ltoa ((atoi (getScanNum()) + 1), buff, 10));
    return atol (getScanNum());
  }                          */
  char* getTypeScan (short which) {return typeScan [which]; }
  char* getRMin (short which) {return rMin [which]; }
  char* getRMax (short which) {return rMax [which]; }
  char* getRStep (short which) {return rStep [which]; }
  char* getWMin (short which) {return wMin [which]; }
  char* getWMax (short which) {return wMax [which]; }
  char* getWStep (short which) {return wStep [which]; }
  char* getW2 (short which) {return w2 [which]; }
  char* getW3 (short which) {return w3 [which]; }
  char*	getScanMode (short which) {return scanMode [which]; }
  char*	getReplicates (short which) {return replicates [which]; }
  char*	getOutputMode (short which) {return outputMode [which]; }
  char*	getOutputType (short which) {return outputType [which]; }
  char*	Channels (short which) {return channels [which]; }
  char	NoDelayCal() {return noDelayCal; }
  char* FilterLevel() {return filterLevel; }

  char* getFilePath()				{return filePath; }
  char* getScanNum()				{return (scanNum); }
  char* getScanTotal()			{return (scanTotal); }
  char* getScanCell()				{return (scanCell); }
  char* getScanCondition()	{return (scanCondition); }
  char* getScanType()				{return (scanType); }
  char* getScanDataFile()		{return (scanDataFile); }
  char* getEstCellTime (short which)		{return (estCellTime [which]); }
  char* getEstRotorTime()		{return (estRotorTime); }
  char* getEstTotalTime()		{return (estTotalTime); }
  char* getEstTimeLeft() {return (timeLeft); }
  void putTypeScan (short which, char* data)
    {strcpy (typeScan [which], data); }
  void putRMin (short which, char* data)
    {strcpy (rMin [which], data); }
  void putRMax (short which, char* data)
    {strcpy (rMax [which], data); }
  void putRStep (short which, char* data)
    {strcpy (rStep [which], data); }
  void putWMin (short which, char* data)
    {strcpy (wMin [which], data); }
  void putWMax (short which, char* data)
    {strcpy (wMax [which], data); }
  void putWStep (short which, char* data)
    {strcpy (wStep [which], data); }
  void putW2 (short which, char* data)
    {strcpy (w2 [which], data); }
  void putW3 (short which, char* data)
    {strcpy (w3 [which], data); }
  void putScanMode (short which, char* data)
    {strcpy (scanMode [which], data); }
  void putReplicates (short which, char* data)
    {strcpy (replicates [which], data); }
  void putOutputMode (short which, char* data)
    {strcpy (outputMode [which], data); }
  void putOutputType (short which, char* data)
    {strcpy (outputType [which], data); }
  void Channels (short which, char* data)
    {strcpy (channels [which], data); }
  void NoDelayCal (char state)
    {noDelayCal = state; }
  void FilterLevel (char* level)
    {strcpy (filterLevel, level); }
  void putFilePath (char* name)
    { strcpy (filePath, name); }
  void putScanNum (char* data)
    {strcpy (scanNum, data); }
  void putScanTotal (char* data)
    {strcpy (scanTotal, data); }
  void putScanCell (char* data)
    {strcpy (scanCell, data); }
  void putScanCondition (char* data)
    {strcpy (scanCondition, data); }
  void putScanType (char* data)
    {strcpy (scanType, data); }
  void putScanDataFile (char* data)
    {strcpy (scanDataFile, data); }
  void putEstCellTime (short which, char* data)
    {strcpy (estCellTime [which], data); }
  void putEstRotorTime (char* data)
    {strcpy (estRotorTime, data); }
  void putEstTotalTime (char* data)
    {strcpy (estTotalTime, data); }
  void putEstTimeLeft (char* data)
    {strcpy (timeLeft, data); }
};

struct scanSettingsStruct
{//This structure holds the data for wavelength scan
 int Absorbance,
			Interference;
 int Fourhole;
 int Sixhole;
 int AllIdentical;
 struct CellStruct {
						int Wave;
						int Vel;
						int Equ;
						int None;
						char Min[5];
						char Max[5];
						char Param3[5];
						char Comment[COMMENTLEN];
						 }ScanCellStruct[NUM_CELLS];

};

struct ThelocalfileStruct
{
 char localfile[128];
 char datapath[128];
 BOOL isdirty;
 BOOL isnew;
};


struct VelSetStruct {
 BOOL step;
 BOOL continuous;
 BOOL channel26;
 BOOL channel8;
 char w2[5];
 char w3[5];
 char stepsize[6];
 char replicate[5];
 char filename[64];
 // BEGIN interference control data
 // new interference controls; keep at end of struct to maintain backward
 // compatibility.
 int  chan6But;										// six channel radio button
 int 	blankSub,                   // blank subtraction checkbox
			alignData;                  // align data checkbox
 char pixelsPerFringe [PPF_LEN];  // pixels per fringe edit box
 int	chanA,                      // channel radsio buttons
			chanB,
			chanC,
			chanD,
			insideBut,                  // inside / outside radio buttons
			outsideBut;
 char	insideRad [NUM_CHANS] [RAD_LEN],	// inside / outside channel radii
			outsideRad [NUM_CHANS] [RAD_LEN];
 int	laserOn;                // laser on checkbox
 int	laserCell [9];  				// laser cell number radio buttons
 int	laserHole [2];          // laser rotor holes radio buttons
 int 	simRpmOn;
 char simRpm [sizeof ("60000")];
 char simRpmText [sizeof ("Simulate rpm")];
 char estExpTime [sizeof ("0.999999")];
 // scan detail blank scan setup data
 int	useFile;								// use blank scan file checkbox
 char blankPPF [PPF_LEN];			// blank scan pixels per fringe edit box
 int  blankCell [9];					// blank scan cell # radio buttons
 char blankFile [MAXPATH];
 // END interference control data
};


struct WaveSetStruct
{
 BOOL channel26;
 BOOL channel8;
 char rmax[6];
 char radialstep[6];
 char stepsize[4];
 char replicate[4];
 char filename[9];

};

#define RMAX_SIZE		6
#define RSTEP_SIZE  6
#define STEP_SIZE  	4
#define REP_SIZE    4
#define FILE_SIZE   9


struct TOptionStruct
{
 BOOL checkbox1,
		checkbox2,
		checkbox3,
		checkbox4,
		checkbox5,
		checkbox6,
		stopXl;
 char overlays[3];
};


/**************************************************************************
												S c a n S e t t i n g s
**************************************************************************/
class ScanSettings
{
		// struct required for passing transfer buffer address to dialogues
		// refer to member function getXferAdr() below, you big dummy...
		struct scanSettingsStruct scanSetStruct;
			public:
		ScanSettings()
		{  };
		~ScanSettings()
		{  };
};  //scanWSettings  this is the class for wavelength scan
//---------------------------------------------------------------------------
#endif

